/*
 * test of option.h
 */
#include <stdio.h>
#include <string.h>
#include <option.h>

enum {
  BLACK,
  BLUE,
  GREEN,
  CYAN,
  RED,
  MAGENTA,
  BROWN,
  LIGHTGRAY,
  DARKGRAY,
  LIGHTBLUE,
  LIGHTGREEN,
  LIGHTCYAN,
  LIGHTRED,
  LIGHTMAGENTA,
  YELLOW,
  WHITE
};
char *color[] = {
  "BLACK",
  "BLUE",
  "GREEN",
  "CYAN",
  "RED",
  "MAGENTA",
  "BROWN",
  "LIGHTGRAY",
  "DARKGRAY",
  "LIGHTBLUE",
  "LIGHTGREEN",
  "LIGHTCYAN",
  "LIGHTRED",
  "LIGHTMAGENTA",
  "YELLOW",
  "WHITE",
};
char buf[256];

/*
 * global variables for example
 */
char title[64] = "test program of option.h";
char c = 'c';
int flag = !0;
int number = 0;
int width = 500, height = 400;
float f = 0.001;
double d = 0.002;

/*
 * to show variables for example
 */
void usage( FILE *fp )
{
  fprintf( fp, "options ... \n" );
  fprintf( fp, "\t-t name:    to set string (%s).   \n", title );
  fprintf( fp, "\t-c char:    to set character (%c).\n", c );
  fprintf( fp, "\t-on[-]:     to set flag (%s).     \n", flag?"ON":"OFF" );
  fprintf( fp, "\t-color enum to set enumerate (%s) \n", color[number] );
  fprintf( fp, "\t-geom WxH:  to set ints (%1dx%1d).\n", width, height );
  fprintf( fp, "\t-f float:   to set float (%f).    \n", f );
  fprintf( fp, "\t-d double:  to set double (%f).   \n", d );
  fprintf( fp, "\t-help:      show this help.       \n" );
}

void main( int argc, char *argv[] )
{
  int i;
  /*
   * procedures for an example
   */
  printf( "\n*** DEFAULT SETTINGS ***\n\n" );
  usage( stdout );
  /*
   * analyze options and get results
   */
  /*
   * analyze options
   */
  scan_option( argc, argv, "-t %s", title );
  scan_option( argc, argv, "-c %c", &c );
  scan_option( argc, argv, "-on[-]", &flag );
  strcpy( buf, "-color " );
  for ( i=0; i<16; i++ ){
    strcat( buf, color[i] );
    strcat( buf, " " );
  }
  scan_option( argc, argv, buf, &number );
  scan_option( argc, argv, "-geom %dx%d", &width, &height );
  scan_option( argc, argv, "-f %f", &f );
  scan_option( argc, argv, "-d %lf", &d );
  if ( scan_option( argc, argv, "-help" ) ){
    printf( "\n*** SETTINGS BY YOUR OPTIONS ***\n\n" );
    usage( stdout );
    fprintf( stdout, "There is help option.\n" );
    exit( 0 );
  }
  /*
   * procedures for an example
   */
  printf( "\n*** SETTINGS BY YOUR OPTIONS ***\n\n" );
  usage( stdout );

  exit( 0 );
}
